<?php
# This file is distributed under GNU GPLv1 and further versions.
# This file was written by Zdenek Styblik
# This file is part of weathermap4rrd-ng
#
# Zdenek Styblik
# e-mail: zdenek <dot> styblik <at> gmail <dot> com
# jabber: stybla <at> danysek <dot> cz
#
# Last update: 2008-01-31
#
class formnode extends defaultLib {
	public $auto_index;
	public $scriptname;
	public $settings;

	function __construct() {
		$this->auto_index = -1;
		$this->settings = new StdClass;
		$settings = $this->settings;
		$settings->config = new StdClass;
		$settings->xmlobject = new StdClass;
		$settings->xmlobject->debug = new StdClass;
		$this->scriptname = $this->getScriptname();
	}

	function __destruct() {
		$this->settings;
		$this->auto_index;
	}

	public function init() {
		if (isset($_GET['action'])) {
			$action = $this->stripMe($_GET['action']);
		} else {
			$action = "foo";
		}
		switch ($action) {
			case 'new':
				$this->nodeAddForm();
				break;
			case 'edit':
				$this->nodeEditForm();
				break;
			case 'addnode':
				$this->nodeAdd();
				break;
			case 'editnode':
				$this->nodeEdit();
				break;
			case 'delete':
				$this->nodeDelete();
				break;
			default:
				$this->nodeAddForm();
				break;
		}
	}

	private function nodeAddForm() {
		$xml = $this->settings->xmlobject;
		# list icon dir
		$xml->incon = new StdClass;
		# icons
		$xml->icon = $this->getImages('nodeicons/');
		# arrow types
		$xml->labeltype = new StdClass;
		$this->auto_index++;
		$xml->labeltype->entry[$this->auto_index] = new StdClass;
		$xml->labeltype->entry[$this->auto_index]->name = "square";
		$this->auto_index++;
		$xml->labeltype->entry[$this->auto_index] = new StdClass;
		$xml->labeltype->entry[$this->auto_index]->name = "round";
		$xml->check[0] = new StdClass;
		$xml->check[0]->name = "none";
		$xml->check[1] = new StdClass;
		$xml->check[1]->name = "ping";
		$xml->check[2] = new StdClass;
		$xml->check[2]->name = "tcp";
		# layout
		$this->settings->layout = "form_node.xsl";
		# form
		## set formaction
		$xml->formaction = "{$this->scriptname}?module=formnode&#38;action=addnode";
		# form buttons
		$xml->button = new StdClass;
		## add button
		$this->auto_index++;
		$xml->button->entry[$this->auto_index] = new StdClass;
		$xml->button->entry[$this->auto_index]->url = "javascript:document.formnode.submit()";
		$xml->button->entry[$this->auto_index]->urllabel = "Add";
		$xml->button->entry[$this->auto_index]->margin = "100";
		## cancel button
		$this->auto_index++;
		$xml->button->entry[$this->auto_index] = new StdClass;
		$xml->button->entry[$this->auto_index]->url = "{$this->scriptname}?module=editor";
		$xml->button->entry[$this->auto_index]->urllabel = "Cancel";
		$xml->button->entry[$this->auto_index]->margin = "150";
	}

	private function nodeAdd() {
		$RC = 0;
		$path = $this->getPath();
		if (isset($_POST['name']) && !empty($_POST['name'])) {
			$node = new StdClass;
			# node name
			$node->name = $this->stripMe($_POST['name']);
			$node->name = preg_replace('/^\s+/', '', $node->name);
			$node->name = preg_replace('/\s+$/', '', $node->name);
			$node->name = preg_replace('/\s+/', '_', $node->name);
			if (empty($node->name)) {
				$this->setDebugMsg("node-name is empty;");
				$RC = 1;
			}
			if (is_numeric(substr($node->name, 0, 1))) {
				$this->setDebugMsg("node-name starts with number!;");
				$RC = 1;
			}
			# node position
			if (isset($_POST['x']) && is_numeric($_POST['x']) && isset($_POST['y']) && is_numeric($_POST['y'])) {
				$this->setValue('x', $node, 1);
				$this->setValue('y', $node, 1);
			} else {
				$this->setDebugMsg("node x or y position not set;");
				$RC = 1;
			}
			# node label
			if (isset($_POST['label'])) {
				$var = $this->stripMe($_POST['label']);
				$var = preg_replace('/^\s+/', '', $var);
				$var = preg_replace('/\s+$/', '', $var);
				if (empty($var)) {
					$this->setDebugMsg("label is empty;");
					$RC = 1;
				} else {
					$node->label = $var;
				}
			} else {
				$this->setDebugMsg("label is empty;");
				$RC = 1;
			}
			# node label type
			if (isset($_POST['labeltype']) && ($_POST['labeltype'] == 'round')) {
				$node->labeltype = 'round';
			} else {
				$node->labeltype = 'square';
			}
			# node icon
			if (isset($_POST['icon']) && !empty($_POST['icon'])) {
				if (file_exists("{$path}nodeicons/{$_POST['icon']}")) {
					# node icon
					$node->icon = "nodeicons/{$_POST['icon']}";
					# node icon pos
					if (isset($_POST['iconx']) && is_numeric($_POST['iconx']) && isset($_POST['icony']) && is_numeric($_POST['icony'])) {
						$this->setValue('iconx', $node, 1);
						$this->setValue('icony', $node, 1);
					}
					# node icon transparency
					$this->setValue('icontpt', $node, 1);
					# node icon resize
					$this->setValue('iconresize', $node, 1);
				}// if file exists
			} // if isset $_POST['icon']
			# node info url
			$this->setValue('infourl', $node, 0);
			# node ip
			if (isset($_POST['ip']) && @inet_pton($_POST['ip']) !== false) {
				$node->ip = $this->stripMe($_POST['ip']);
			}
			# node check
			if (isset($_POST['checkmethod'])) {
				switch ($_POST['checkmethod']):
				case 'tcp':
					if (isset($_POST['checkport']) && is_numeric($_POST['checkport']) && $_POST['checkport'] > 0 && $_POST['checkport'] < 65535) {
						$node->check = "tcp:{$_POST['checkport']}";
					}
					break;
				case 'ping':
					$node->check = "ping";
					break;
				default:
					# none
					break;
				endswitch;
			}
			require_once "{$path}lib/configfile.php";
			$configfile = new config_file();
			$configfile->readConfig();
			$config = $configfile->getConfig();
			if (isset($config->nodes->{$node->name})) {
				// error
				// todo - this is not supported yet and i have doubts it ever will be
				// reason - duplicit xml node name
				$this->setDebugMsg("node-name already exists;");
				$RC = 1;
			}
			if ($RC == 0) {
				$config->nodes->{$node->name} = new StdClass;
				$config->nodes->{$node->name} = $node;
				$xml2save = "<root>\n";
				$xml2save.= $this->objToXML($config);
				$xml2save.= "</root>";
				$configfile->writeConfig($xml2save);
				header("Location: {$this->scriptname}?module=editor");
				exit();
			} else {
				$this->nodeAddForm();
				return 50;
			}
		} else {
			// error
			$this->setDebugMsg("node-name is empty;");
			$this->nodeAddForm();
		} // if isset($_POST['name']
	}

	private function nodeEditForm() {
		if (isset($_POST['node']) && !empty($_POST['node'])) {
			$config = $this->settings->config;
			$path = $this->getPath();
			$xml = $this->settings->xmlobject;
			require_once("{$path}lib/configfile.php");
			$configfile = new config_file();
			if ($configfile->readconfig() == false) {
				// error
				require_once "{$path}modules/index.php";
				$index = new index();
				$index->init();
				$this->settings = $index->settings;
				$xml = $this->settings->xmlobject;
				$a = $this->auto_index++;
				$xml->debug = new StdClass;
				$xml->debug->entry[$a] = new StdClass;
				$xml->debug->entry[$a]->text = "config file not found;";
			} else {
				$config = $configfile->getconfig();
				$node = $this->stripMe($_POST['node']);
				if (isset($config->nodes->{$node})) {
					# layout
					$this->settings->layout = 'form_node.xsl';
					$nodeobj = $config->nodes->{$node};
					$xml->name = $node;
					$xml->oldname = $node;
					$xml->x = $nodeobj->x;
					$xml->y = $nodeobj->y;
					$xml->label = $nodeobj->label;
					# list icon dir
					$xml->incon = new StdClass;
					if (isset($nodeobj->icon) && !empty($nodeobj->icon)) {
						$xml->icon = $this->getImages('nodeicons/', $nodeobj->icon);
					} else {
						$xml->icon = $this->getImages('nodeicons/');
					}
					# arrow types
					$xml->labeltype = new StdClass;
					$xml->labeltype->entry[0] = new StdClass;
					$xml->labeltype->entry[0]->name = "square";
					$xml->labeltype->entry[1] = new StdClass;
					$xml->labeltype->entry[1]->name = "round";
					if (isset($nodeobj->labeltype) && $nodeobj->labeltype == 'round') {
						$xml->labeltype->entry[1]->isselected = "yes";
					} else {
						$xml->labeltype->entry[0]->isselected = "yes";
					}
					if (isset($nodeobj->iconx) && is_numeric($nodeobj->iconx)) {
						$xml->iconx = $nodeobj->iconx;
					}
					if (isset($nodeobj->icony) && is_numeric($nodeobj->icony)) {
						$xml->icony = $nodeobj->icony;
					}
					if (isset($nodeobj->icontpt) && $nodeobj->icontpt >= 0 && $nodeobj->icontpt <= 100) {
						$xml->icontpt = $nodeobj->icontpt;
					}
					if (isset($nodeobj->iconresize) && $nodeobj->iconresize >= 0 && $nodeobj->iconresize <= 100) {
						$xml->iconresize = $nodeobj->iconresize;
					}
					if (isset($nodeobj->infourl)) {
						$xml->infourl = $nodeobj->infourl;
					}
					if (isset($nodeobj->ip)) {
						$xml->ip = $nodeobj->ip;
					}
					$xml->check[0] = new StdClass;
					$xml->check[0]->name = "none";
					$xml->check[1] = new StdClass;
					$xml->check[1]->name = "ping";
					$xml->check[2] = new StdClass;
					$xml->check[2]->name = "tcp";
					if (isset($nodeobj->check)) {
						if (preg_match('/^(tcp:)[0-9]{1,5}+$/', $nodeobj->check) == 1) {
							$xml->check[2]->isselected = "yes";
							$xml->checkport = substr($nodeobj->check, 4);
						} else {
							$xml->check[1]->isselected = "yes";
						}
					}
					# form
					## set formaction
					$xml->formaction = "{$this->scriptname}?module=formnode&#38;action=editnode";
					# form buttons
					$xml->button = new StdClass;
					## add button
					$this->auto_index++;
					$xml->button->entry[$this->auto_index] = new StdClass;
					$xml->button->entry[$this->auto_index]->url = "javascript:document.formnode.submit()";
					$xml->button->entry[$this->auto_index]->urllabel = "Update";
					$xml->button->entry[$this->auto_index]->margin = "100";
					## delete button
					$this->auto_index++;
					$xml->button->entry[$this->auto_index] = new StdClass;
					$xml->button->entry[$this->auto_index]->url = "{$this->scriptname}?module=formnode&#38;action=delete&#38;name={$xml->name}";
					$xml->button->entry[$this->auto_index]->urllabel = "Delete";
					$xml->button->entry[$this->auto_index]->margin = "150";
					## cancel button
					$this->auto_index++;
					$xml->button->entry[$this->auto_index] = new StdClass;
					$xml->button->entry[$this->auto_index]->url = "{$this->scriptname}?module=editor";
					$xml->button->entry[$this->auto_index]->urllabel = "Cancel";
					$xml->button->entry[$this->auto_index]->margin = "150";
				} else {
					// error
					$this->setError("requested node doesn't exist;");
				}
			}
		} else {
			// error
			$this->setError("node var not set;");
		}
	}

	private function nodeEdit() {
		if (isset($_POST['name']) && !empty($_POST['name']) && isset($_POST['oldname']) && !empty($_POST['oldname'])) {
			$RC = 0;
			$path = $this->getPath();
			require_once "{$path}lib/configfile.php";
			$configfile = new config_file();
			if ($configfile->readConfig() == false) {
				// error
				$this->setError("config file not found; aborting;");
			} else {
				$config = $configfile->getConfig();
				$name = $this->stripMe($_POST['name']);
				$name = preg_replace('/^\s+/', '', $name);
				$name = preg_replace('/\s+$/', '', $name);
				if (empty($name)) {
					$this->setDebugMsg("name is empty;");
					$RC = 1;
				}
				if (is_numeric(substr($name, 0, 1))) {
					$this->setDebugMsg("node-name starts with number!;");
					$RC = 1;
				}
				$oldname = $this->stripMe($_POST['oldname']);
				$oldname = preg_replace('/^\s+/', '', $oldname);
				$oldname = preg_replace('/\s+$/', '', $oldname);
				if (empty($oldname)) {
					$this->setError("vars not set #2; aborting;");
					$RC = 1;
				}
				if ($name == $oldname) {
					// we don't have to check for duplicity
					if (isset($config->nodes->{$name})) {
						$node = $config->nodes->{$name};
						$unsetold = 0;
					} else {
						$this->setError("node not found; aborting;");
						$RC = 1;
					}
				} else {
					// check for duplicity
					if (isset($config->nodes->{$name})) {
						$this->setDebugMsg("node-name already exists;");
						$RC = 1;
					}
					$node = new StdClass;
					# node name
					$node->name = $name;
					// set unset old node *flag* on :)
					$unsetold = 1;
				} // if name == oldname
				# node 'x' and 'y' position
				if (isset($_POST['x']) && is_numeric($_POST['x']) && isset($_POST['y']) && is_numeric($_POST['y'])) {
					$this->setValue('x', $node, 1);
					$this->setValue('y', $node, 1);
				} else {
					$this->setDebugMsg("node x or y position not set;");
					$RC = 1;
				}
				# node label
				if (isset($_POST['label'])) {
					$var = $this->stripMe($_POST['label']);
					$var = preg_replace('/^\s+/', '', $var);
					$var = preg_replace('/\s+$/', '', $var);
					if (empty($var)) {
						$this->setDebugMsg("label is empty;");
						$RC = 1;
					} else {
						$node->label = $var;
					}
					unset($var);
				} else {
					$this->setDebugMsg("label is empty;");
					$RC = 1;
				}	// if isset(label)
				# node label type
				if (isset($_POST['labeltype']) && $_POST['labeltype'] == 'round') {
					$node->labeltype = 'round';
				} else {
					$node->labeltype = 'square';
				}
				# node icon
				if (isset($_POST['icon']) && !empty($_POST['icon'])) {
					if (file_exists("{$path}nodeicons/{$_POST['icon']}")) {
						# node icon
						$node->icon = "nodeicons/{$_POST['icon']}";
						# node icon pos
						if (isset($_POST['iconx']) && is_numeric($_POST['iconx']) && isset($_POST['icony']) && is_numeric($_POST['icony'])) {
							$this->setValue('iconx', $node, 1);
							$this->setValue('icony', $node, 1);
						}
						# node icon transparency
						$this->setValue('icontpt', $node, 1);
						# node icon resize
						$this->setValue('iconresize', $node, 1);
					} else {
						if (isset($node->icon))
							unset($node->icon);
						if (isset($node->iconx))
							unset($node->iconx);
						if (isset($node->icony))
							unset($node->icony);
						if (isset($node->icontpt))
							unset($node->icontpt);
						if (isset($node->iconresize))
							unset($node->iconresize);
					} // if file exists
				} else {
					if (isset($node->icon))
						unset($node->icon);
					if (isset($node->iconx))
						unset($node->iconx);
					if (isset($node->icony))
						unset($node->icony);
					if (isset($node->icontpt))
						unset($node->icontpt);
					if (isset($node->iconresize))
						unset($node->iconresize);
				} // if isset $_POST['icon']
				# node infourl
				$this->setValue('infourl', $node, 0);
				# node ip
				if (isset($_POST['ip']) && @inet_pton($_POST['ip']) !== false) {
					$node->ip = $this->stripMe($_POST['ip']);
				} else {
					if (isset($node->ip))
						unset($node->ip);
				}
				# node check
				if (isset($_POST['checkmethod'])) {
					switch ($_POST['checkmethod']):
					case 'tcp':
						if (isset($_POST['checkport']) && is_numeric($_POST['checkport']) && $_POST['checkport'] > 0 && $_POST['checkport'] < 65535) {
							$node->check = "tcp:{$_POST['checkport']}";
						}
						break;
					case 'ping':
						$node->check = "ping";
						break;
					default:
						# none
						if (isset($node->check))
							unset($node->check);
						break;
					endswitch;
				} // if isset checkmethod
				if ($RC == 0) {
					if ($unsetold == 1) {
						if (isset($config->nodes->{$oldname})) {
							unset($config->nodes->{$oldname});
							# following foreach could be probably replaced with something better.
							# if you know how to do it better, please let me know. any comments
							# are welcome.
							foreach ($config->links as $link) {
								if ($link->to == $oldname)
									$link->to = $name;
								if ($link->from == $oldname)
									$link->from = $name;
							}
						}
						$config->nodes->{$name} = $node;
					} else {
						# dummy ???
					}
					$xml2save = "<root>\n";
					$xml2save.= $this->objToXML($config);
					$xml2save.= "</root>";
					$configfile->writeconfig($xml2save);
					header("Location: {$this->scriptname}?module=editor");
					exit();
				} else {
					$_POST['node'] = $oldname;
					$this->nodeEditForm();
				}
			} // if configfile->readConfig
		} else {
			$this->setError("vars not set #1; aborting;");
		} // if isset($_POST['name']
	}

	private function nodeDelete() {
		if (isset($_GET['name']) && !empty($_GET['name'])) {
			$name = $this->stripMe($_GET['name']);
			$name = preg_replace('/\s+/', '_', $name);
			$path = $this->getPath();
			require_once "{$path}lib/configfile.php";
			$configfile = new config_file();
			if ($configfile->readconfig() != false) {
				$config = $configfile->getConfig();
				if (isset($config->nodes->{$name})) {
					# following foreach could be probably replaced with something better.
					# if you know how to do it better, please let me know. any comments
					# are welcome.
					foreach ($config->links as $link) {
						if ($link->to == $name) {
							$found = 1;
							$linkname = $link->name;
							break;
						}
						if ($link->from == $name) {
							$found = 1;
							$linkname = $link->name;
							break;
						}
					}
					if ($found == 1) {
						// error
						$this->setError("unset node '{$name}' from link '{$linkname}' first;");
					} else {
						// unset node
						unset($config->nodes->{$name});
						// convert obj-2-xml
						$xml2save = "<root>\n";
						$xml2save.= $this->objToXML($config);
						$xml2save.= "</root>";
						// saveXML
						$configfile->writeconfig($xml2save);
						// redirect to index page
						header("Location: {$this->scriptname}?module=editor");
						exit();
					}
				} else {
					// error
					$this->setError("node not found; aborting;");
					return 10;
				}
			} else {
				// error
				$this->setError("config file not found; aborting;");
				return 10;

			}
		} else {
			// error
			$this->setError("node-name string empty; aborting;");
			return 10;
		}
	}

	// @return object;
	public function getImages($dir = null, $match = null) {
		$i = 0;
		$retval = new StdClass;
		$retval->entry[$i] = new StdClass;
		$retval->entry[$i]->name = "none";
		$retval->incoming = "none";
		$i++;
		if (!empty($dir) && is_dir($dir)) {
			$ls = scandir($dir);
			foreach ($ls as $k=>$v) {
				if (strstr($v, '.png')) {
					$this->auto_index++;
					$retval->entry[$i] = new StdClass;
					$retval->entry[$i]->name = $v;
					if (('nodeicons/' . $v) == $match) {
						$retval->entry[$i]->isselected = "yes";
						$retval->iconimg = '../nodeicons/' . $v;
					}
					$i++;
				}
			} // foreach $ls
		} // is_dir
		return $retval;
	}

	// @return $obj
	// $value: mixed;
	// $obj: object;
	// $type: 0 - string; 1 - num;
	private function setValue($value, $obj, $type = 0) {
		if (isset($_POST[$value])) {
			if ($type == 0 && !empty($_POST[$value])) {
				$var = $this->stripMe($_POST[$value]);
				$var = preg_replace('/^\s+/', '', $var);
				$var = preg_replace('/\s+$/', '', $var);
				if (!empty($var))
					$obj->{$value} = $var;
			} elseif ($type == 1 && is_numeric($_POST[$value])) {
				$obj->{$value} = $this->stripMe($_POST[$value]);
			}
		} else {
			if (isset($obj->{$value}) && empty($_POST[$value])) {
				unset($obj->{$value});
			}
		}
		$newobj = & $obj;
		return $newobj;
	}

	// @return null;
	private function setError($errormsg = null) {
		$path = $this->getPath();
		require_once "{$path}modules/editor.php";
		$editor = new editor();
		$editor->init();
		$this->settings = $editor->settings;
		$this->auto_index++;
		$xml = $this->settings->xmlobject;
		$xml->debug->entry[$this->auto_index] = new StdClass;
		$xml->debug->entry[$this->auto_index]->text = $errormsg;
	}

	// @return null;
	private function setDebugMsg($text = null) {
		if (!is_null($text)) {
			$xml = $this->settings->xmlobject;
			$this->auto_index++;
			$xml->debug->entry[$this->auto_index] = new StdClass;
			$xml->debug->entry[$this->auto_index]->text = $text;
		}
	}
}
?>
